<script lang="ts">
import { MetaInfo } from 'vue-meta/types/vue-meta';
import { getPageMetadata } from '~/common/meta';
import { Accordion } from '~/components/solutions/index.vue';
import { SolutionsResourceCards } from '~/components/solutions/index.vue';
import {
  GitlabDuoWorkflowContent,
  GitlabDuoWorkflowHero,
} from '~/components/gitlab-duo/workflow/index.vue';

export default {
  name: 'GitlabDuoWorkflow',
  components: {
    Accordion,
    GitlabDuoWorkflowContent,
    GitlabDuoWorkflowHero,
    SolutionsResourceCards,
  },
  layout: 'gitlab-duo-workflow',
  async asyncData({ $content, i18n }) {
    try {
      const content = await $content(
        i18n.locale,
        '/gitlab-duo/workflow',
      ).fetch();
      return { content };
    } catch (e) {
      throw new Error(e);
    }
  },
  data(): { submitted: boolean; isOpenIndex: number } {
    return {
      submitted: false,
      isOpenIndex: 0,
    };
  },
  head(): MetaInfo {
    return {
      ...getPageMetadata(
        (this as any).content,
        this.$route.path,
        this.$nuxtI18nHead({ addSeoAttributes: true }),
      ),
    };
  },
  mounted() {
    this.$nuxt.$on('submit', () => {
      this.submitted = true;
    });
  },
  methods: {
    onFormSubmit() {
      this.$nuxt.$emit('submit');
      this.submitted = true;
      this.$refs.targetRef.scrollIntoView({ behavior: 'smooth' });
    },
    toggleController(index: number) {
      if (this.isOpenIndex === index) {
        this.isOpenIndex = -1;
        return;
      }
      this.isOpenIndex = index;
    },
  },
};
</script>
<template>
  <div ref="targetRef">
    <TransitionGroup v-if="!submitted" name="content" tag="div">
      <div key="hero">
        <GitlabDuoWorkflowHero
          v-if="content.duoCombinedHero"
          :data="content.duoCombinedHero"
        />
      </div>
      <div v-if="content.aiContent" key="aicontent" class="ai-content">
        <SlpContainer>
          <SlpRow class="slp-pt-48 slp-pb-0 slp-py-md-96">
            <SlpColumn :cols="6" class="slp-pr-md-32">
              <div class="eyebrow">
                <SlpIcon
                  name="ai-code-suggestions"
                  class="icon"
                  variant="marketing"
                  size=""
                />
                <SlpTypography variant="body2-bold" tag="span">
                  {{ content.aiContent.aiCard.eyebrow }}
                </SlpTypography>
              </div>
              <SlpTypography
                class="slp-pb-16 text-white"
                variant="heading3-bold"
                tag="h2"
              >
                {{ content.aiContent.aiCard.title }}
              </SlpTypography>
              <SlpTypography
                variant="body1"
                tag="p"
                class="slp-pb-24 slp-pb-md-0"
              >
                {{ content.aiContent.aiCard.body }}
              </SlpTypography>
            </SlpColumn>
            <SlpColumn :cols="6" class="slp-pl-md-32" size="lg">
              <div class="items-wrapper">
                <Accordion
                  v-for="(item, index) in content.aiContent.aiAccordion"
                  :key="item.header"
                  :data="item"
                  :is-open="isOpenIndex == index"
                  :is-white="true"
                  @toggleController="toggleController(index)"
                />
              </div>
            </SlpColumn>
          </SlpRow>
        </SlpContainer>
      </div>

      <GitlabDuoWorkflowContent
        key="content"
        class="slp-pt-md-0 slp-py-mt-64"
        :form="content.form"
        :cards="content.cards"
        :disclaimer="content.disclaimer"
        @submit="onFormSubmit"
      />
    </TransitionGroup>
    <TransitionGroup v-if="submitted" name="content" tag="div">
      <GitlabDuoWorkflowHero
        v-if="content.submittedHero"
        key="hero"
        :data="content.submittedHero"
      />
      <SolutionsResourceCards
        v-if="content.resources"
        v-bind="content.resources"
        key="resources"
      />
    </TransitionGroup>
  </div>
</template>

<style lang="scss" scoped>
.ai-content {
  background: $color-surface-700;
  color: $color-text-50;
}

:deep(.slp-btn):not(.accordion__button--white) {
  text-decoration: none;

  &:hover,
  &:active {
    text-decoration: none;
    color: $color-surface-700;
    background: $color-surface-50;

    .slp-icon {
      transform: none;
    }
  }
}

p {
  color: $color-surface-400;
}

.eyebrow {
  margin-bottom: 26px;
  position: relative;
  padding: 4px 12px;
  display: inline-flex;
  align-items: center;

  .slp-icon {
    width: 20px;
    height: 20px;
    margin-right: 5px;
    color: linear-gradient(
        89.09deg,
        #e1986d -1.12%,
        #7759c2 102.06%,
        #6e43d3 102.07%
      )
      border-box;
  }

  &:before {
    content: '';
    position: absolute;
    top: 0;
    right: 0;
    bottom: 0;
    left: 0;
    border-radius: 20px;
    border: 1.5px solid transparent;
    background: linear-gradient(
        89.09deg,
        #e1986d -1.12%,
        #7759c2 102.06%,
        #6e43d3 102.07%
      )
      border-box;
    -webkit-mask:
      linear-gradient(#fff 0, #fff 0) padding-box,
      linear-gradient(#fff 0, #fff 0);
    -webkit-mask:
      linear-gradient(#fff 0 0) padding-box,
      linear-gradient(#fff 0 0);
    -webkit-mask-composite: xor;
    mask-composite: exclude;
  }
}

.items-wrapper {
  width: 100%;
  &:deep .accordion,
  &:deep .accordion__header,
  &:deep .slp-icon {
    color: $color-text-50;
  }
  &:deep .accordion__icon:before,
  &:deep .accordion__icon:after {
    background-color: $color-text-50;
  }

  &:deep svg {
    width: 24px !important;
  }

  &:deep .accordion .summary {
    border-top: 1px solid $color-surface-600;
    padding: 32px 0;
  }

  &:deep .content {
    color: $color-surface-400;

    a {
      color: $color-accent-400;
    }
  }

  @media (max-width: 1169px) {
    max-width: 100%;
  }
  & > :last-child {
    margin-bottom: 0;
  }
}

.disclaimer {
  background-color: $color-surface-700;
  padding: 64px 0;
  color: $color-surface-400;
}
</style>
